// Dallas DS18B20 Thermometer
// Chin-Shiuh Shieh on 2014-11-29

#define DQ 20

// Software One-Wire
// Chin-Shiuh Shieh on 2014-11-29

#define One_Wire_OK    0
#define One_Wire_ERROR 1

unsigned char One_Wire_Initialization(void){
  unsigned char ack;
  pinMode(DQ,OUTPUT);digitalWrite(DQ,LOW);delayMicroseconds(480);digitalWrite(DQ,HIGH);
  pinMode(DQ,INPUT);delayMicroseconds(90);ack=digitalRead(DQ);delayMicroseconds(390);
  if(ack==LOW)return(One_Wire_OK);else return(One_Wire_ERROR);
}

void One_Wire_Write_Byte(unsigned char shift_buffer){
  unsigned char i;
  pinMode(DQ,OUTPUT);
  for(i=0;i<8;i++){
    digitalWrite(DQ,LOW);delayMicroseconds(15);
    if(shift_buffer%2==1)digitalWrite(DQ,HIGH);else digitalWrite(DQ,LOW);shift_buffer>>=1;delayMicroseconds(15);
    digitalWrite(DQ,HIGH);delayMicroseconds(30);
  }
}

unsigned char One_Wire_Read_Byte(void){
  unsigned char i,shift_buffer=0;
  for(i=0;i<8;i++){
    pinMode(DQ,OUTPUT);digitalWrite(DQ,LOW);delayMicroseconds(2);pinMode(DQ,INPUT);digitalWrite(DQ,HIGH);
    delayMicroseconds(5);shift_buffer>>=1;if(digitalRead(DQ)==HIGH)shift_buffer+=128;delayMicroseconds(40);
    pinMode(DQ,OUTPUT);digitalWrite(DQ,HIGH);delayMicroseconds(10);
  }
  return(shift_buffer);
}

void setup(void){
  Serial.begin(9600);
}

void loop(void){
  float temperature;
  if(One_Wire_Initialization()==One_Wire_OK){
    One_Wire_Write_Byte(0xCC); // Skip ROM
    One_Wire_Write_Byte(0x44); // Convert T
  }
  delay(750);
  if(One_Wire_Initialization()==One_Wire_OK){
    One_Wire_Write_Byte(0xCC); // Skip ROM
    One_Wire_Write_Byte(0xBE); // Read Scratchpad
    temperature=(float)(One_Wire_Read_Byte()+One_Wire_Read_Byte()*256)/16.0;
    Serial.println(temperature);
  }
  delay(1000);
}
